-- ############################################################################
-- ##                                                                        ##
-- ##  D B T U T O O L S / D B T U T R A F F I C . D D L                     ##
-- ##                                                                        ##
-- ## ---------------------------------------------------------------------- ##
-- ##                                                                        ##
-- ##  Job .......: Script for creating the objects (tables,...)             ##
-- ##               for the dbtutraffic tool.                                ##
-- ##                                                                        ##
-- ## ---------------------------------------------------------------------- ##
-- ##                                                                        ##
-- ##  Copyright (C) 2002  Daniel Scheibli                                   ##
-- ##                                                                        ##
-- ##  This program is free software; you can redistribute it and/or modify  ##
-- ##  it under the terms of the GNU General Public License as published by  ##
-- ##  the Free Software Foundation; either version 2 of the License, or     ##
-- ##  (at your option) any later version.                                   ##
-- ##                                                                        ##
-- ##  This program is distributed in the hope that it will be useful, but   ##
-- ##  WITHOUT ANY WARRANTY; without even the implied warranty of            ##
-- ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         ##
-- ##  GNU General Public License for more details.                          ##
-- ##                                                                        ##
-- ##  You should have received a copy of the GNU General Public License     ##
-- ##  along with this program; if not, write to the Free Software           ##
-- ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                ##
-- ##  MA 02111-1307, USA.                                                   ##
-- ##                                                                        ##
-- ## ---------------------------------------------------------------------- ##
-- ##                                                                        ##
-- ##  Remark ....: <none>                                                   ##
-- ##                                                                        ##
-- ## ---------------------------------------------------------------------- ##
-- ##                                                                        ##
-- ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>           ##
-- ##  Date ......: 2002-08-27                                               ##
-- ##  Changes ...: ----- dbtutraffic.ddl V00.99/R020 ---------------------- ##
-- ##               <none>                                                   ##
-- ##               ----- dbtutraffic.ddl V00.99/R011 ---------------------- ##
-- ##               <none>                                                   ##
-- ##                                                                        ##
-- ############################################################################



-- ##### Defaults
-- ----------------------------------------------------------------------------
SET CURRENT SCHEMA dbtutools;
-- ----------------------------------------------------------------------------



-- ##### Presettings 
-- ----------------------------------------------------------------------------
UPDATE COMMAND OPTIONS USING C OFF;
-- ----------------------------------------------------------------------------



-- ##### Create objects, grant privileges (and create statistics)
-- ----------------------------------------------------------------------------
CREATE TABLE dbtutraffic01
(
 rowid INTEGER  NOT NULL,
 value CHAR(50) NOT NULL,
 PRIMARY KEY(rowid)
);
-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
INSERT INTO dbtutraffic01 VALUES ( 1, 'initial' );
INSERT INTO dbtutraffic01 VALUES ( 2, 'initial' );
INSERT INTO dbtutraffic01 VALUES ( 3, 'initial' );
INSERT INTO dbtutraffic01 VALUES ( 4, 'initial' );
INSERT INTO dbtutraffic01 VALUES ( 5, 'initial' );
-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
GRANT ALL ON TABLE dbtutraffic01 TO PUBLIC;
-- ----------------------------------------------------------------------------



-- ##### Create objects, grant privileges (and create statistics)
-- ----------------------------------------------------------------------------
CREATE TABLE dbtutraffic02
(
 rowid INTEGER       NOT NULL,
 time  TIMESTAMP     NOT NULL DEFAULT CURRENT TIMESTAMP,
 value VARCHAR(3000) NOT NULL,
 PRIMARY KEY(rowid)
);
-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
GRANT ALL ON TABLE dbtutraffic02 TO PUBLIC;
-- ----------------------------------------------------------------------------



-- ##### Commit work
-- ----------------------------------------------------------------------------
COMMIT WORK;
-- ----------------------------------------------------------------------------


