/* ######################################################################### */
/* ##                                                                     ## */
/* ##  D B T U T O O L S / D B T U W H O . C                              ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Job .......: Implements an "who" command like alternative to       ## */
/* ##                - LIST APPLICATIONS SHOW DETAIL                      ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Copyright (C) 2002  Daniel Scheibli                                ## */
/* ##                                                                     ## */
/* ##  This program is free software; you can redistribute it and/or      ## */
/* ##  modify it under the terms of the GNU General Public License        ## */
/* ##  as published by the Free Software Foundation; either version 2     ## */
/* ##  of the License, or (at your option) any later version.             ## */
/* ##                                                                     ## */
/* ##  This program is distributed in the hope that it will be useful,    ## */
/* ##  but WITHOUT ANY WARRANTY; without even the implied warranty of     ## */
/* ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      ## */
/* ##  GNU General Public License for more details.                       ## */
/* ##                                                                     ## */
/* ##  You should have received a copy of the GNU General Public License  ## */
/* ##  along with this program; if not, write to the Free Software        ## */
/* ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,             ## */
/* ##  MA  02111-1307, USA.                                               ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Remark ....: <none>                                                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>        ## */
/* ##  Date ......: 2002-05-12                                            ## */
/* ##  Changes ...: ----- dbtuwho.c V00.99/R020 ------------------------- ## */
/* ##               <none>                                                ## */
/* ##               ----- dbtuwho.c V00.99/R011 ------------------------- ## */
/* ##               <none>                                                ## */
/* ##               ----- dbtuwho.c V00.99/R010 ------------------------- ## */
/* ##               2002-07-27 - Additional fields and parameters (--all, ## */
/* ##                            --nodenum, --dbalias and --nname).       ## */
/* ##               ----- dbtuwho.c V00.99/R003 ------------------------- ## */
/* ##               2002-06-07 - Seperated parsing for APPL_INFO from     ## */
/* ##                            parsing its elements.                    ## */
/* ##               2002-06-07 - Added two forgotten free() calls.        ## */
/* ##               ----- dbtuwho.c V00.99/R002 ------------------------- ## */
/* ##               <none>                                                ## */
/* ##                                                                     ## */
/* ######################################################################### */



/* ##### Presettings */
/* ------------------------------------------------------------------------- */
#include "libdbtubase.h"
/* ------------------------------------------------------------------------- */





/* ######################################################################### */
/* ##                                                                     ## */
/* ##   < M A I N >                                                       ## */
/* ##                                                                     ## */
/* ######################################################################### */
int main( int argc, char *argv[] )
{
 /* ##### Presettings */
 /* ------------------------------------------------------------------------ */
 int                           iParamCoordNodeNumFlag   = 0; 
 int                           iParamClientDbAliasFlag  = 0;
 int                           iParamClientNnameFlag    = 0;
 int                           iParamHumanReadableFlag  = 0;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 struct sqlm_recording_group   asMonSwitch[SQLM_NUM_GROUPS]; 
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 struct sqlma                 *psSqlMaStruct = NULL;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 void                         *pvStreamBuffer;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 void                         *pvFoundAppl           = NULL; 
 void                         *pvFoundApplInfo       = NULL;
 void                         *pvFoundCoordNodeNum   = NULL;
 void                         *pvFoundDbName         = NULL; 
 void                         *pvFoundClientDbAlias  = NULL;  
 void                         *pvFoundAuthId         = NULL;
 void                         *pvFoundApplName       = NULL;
 void                         *pvFoundAgentId        = NULL;
 void                         *pvFoundApplStatus     = NULL;
 void                         *pvFoundApplIdleTime   = NULL;
 void                         *pvFoundClientNname    = NULL;
 void                         *pvFoundExecutionId    = NULL;
 void                         *pvFoundClientPid      = NULL;
 void                         *pvFoundClientProtocol = NULL;
 void                         *pvFoundApplId         = NULL;
 void                         *pvFoundAgent          = NULL;
 void                         *pvFoundAgentPid       = NULL;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */ 
 struct sqlm_header_data     **ppsElementAppl;
 struct sqlm_header_data     **ppsElementApplInfo;
 struct sqlm_header_data     **ppsElementAgent;
 struct sqlm_header_data     **ppsDummy;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */ 
 int                           iFoundAppl;
 int                           iFoundAgent;
 int                           iFoundAgentPid;
 int                           iLoopAppl;
 int                           iLoopAgent;
 int                           iLoopAgentPid;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 int                           iCallRc;
 int                           aiCallRc[16];
 char                          acDummy[64];
 int                           iDummy;
 int                           I;
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 int                           iProgRc = 0;
 /* ------------------------------------------------------------------------ */
 


 /* ##### "Prevent nested IF's"-Loop */
 /* ------------------------------------------------------------------------ */
 for(;;)
 {
  /* ##### Print program version */
  /* ----------------------------------------------------------------------- */
  fprintf(STDOUT, "%s",                    NEWLINE);
  fprintf(STDOUT, "DBTUWHO V00.99/R010%s", NEWLINE);
  fprintf(STDOUT, "%s",                    NEWLINE);
  /* ----------------------------------------------------------------------- */



  /* ##### Check and process the given arguments */
  /* ----------------------------------------------------------------------- */
  for( I = 1; I < argc; I++ )
  {
   if( STRCMP(argv[I], "--dbalias") == 0 ) { iParamClientDbAliasFlag = 1; continue; }
   if( STRCMP(argv[I], "--nname") == 0 )   { iParamClientNnameFlag   = 1; continue; }
   if( STRCMP(argv[I], "--nodenum") == 0 ) { iParamCoordNodeNumFlag  = 1; continue; }
   if( STRCMP(argv[I], "--human") == 0 )   { iParamHumanReadableFlag = 1; continue; }
   /* ##### If all additional fields are required,... */
   if( STRCMP(argv[I], "--all") == 0 )
   {
    iParamClientDbAliasFlag = 1;   
    iParamClientNnameFlag   = 1;
    iParamCoordNodeNumFlag  = 1;
    iParamHumanReadableFlag = 1;     
    continue;
   }
   /* ##### Otherwise (unknown parameters),... */
   fprintf(STDERR, "===> ERROR: Unknown argument was given.%s",  NEWLINE);
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,       NEWLINE);
   fprintf(STDERR, "%s",                                         NEWLINE);
   fprintf(STDERR, "                                .---------------------------------.%s", NEWLINE);
   fprintf(STDERR, "                                V                                 |%s", NEWLINE);
   fprintf(STDERR, "Usage .......: >>--- dbtuwho -------+-------------------------+---+---><%s", NEWLINE);
   fprintf(STDERR, "                                    |                         |%s", NEWLINE);
   fprintf(STDERR, "                                    |   +--- --dbalias ---+   |%s", NEWLINE);   
   fprintf(STDERR, "                                    |   |                 |   |%s", NEWLINE);
   fprintf(STDERR, "                                    +---+--- --nname -----+---+%s", NEWLINE);   
   fprintf(STDERR, "                                    |   |                 |   |%s", NEWLINE);
   fprintf(STDERR, "                                    |   +--- --nodenum ---+   |%s", NEWLINE);
   fprintf(STDERR, "                                    |                         |%s", NEWLINE);
   fprintf(STDERR, "                                    +---+--- --human ---+-----+%s", NEWLINE);   
   fprintf(STDERR, "                                        |               |%s", NEWLINE);
   fprintf(STDERR, "                                        +--- --all -----+%s", NEWLINE);   
   fprintf(STDERR, "%s",                                         NEWLINE);
   fprintf(STDERR, "Sample ......: dbtuwho --nodenum --dbalias --nname%s", NEWLINE);  
   fprintf(STDERR, "%s",                                         NEWLINE);
   fprintf(STDERR, "Arguments ...: --dbalias   Additional to the standard output, the%s", NEWLINE);
   fprintf(STDERR, "                           client database alias is displayed.%s",    NEWLINE);
   fprintf(STDERR, "               --nname     Additional to the standard output, the%s", NEWLINE);
   fprintf(STDERR, "                           client nname is displayed.%s",             NEWLINE);
   fprintf(STDERR, "               --nodenum   Additional to the standard output, the%s", NEWLINE);
   fprintf(STDERR, "                           coordinating node number is displayed.%s",   NEWLINE);
   fprintf(STDERR, "               --human     Print fields in human readable format (for%s",   NEWLINE);
   fprintf(STDERR, "                           example when communicating with TCP/IP, the%s",  NEWLINE);
   fprintf(STDERR, "                           \"Appl Id\" is displayed as \"IP Address\").%s", NEWLINE);
   fprintf(STDERR, "               --all       Enables all other options.%s", NEWLINE);
   fprintf(STDERR, "%s",                                         NEWLINE);
   return(1); 
  }
  /* ----------------------------------------------------------------------- */



  /* ##### Check wether or not the statement monitor switch is set */
  /* ----------------------------------------------------------------------- */
  asMonSwitch[SQLM_UOW_SW].input_state         = SQLM_HOLD;
  asMonSwitch[SQLM_STATEMENT_SW].input_state   = SQLM_HOLD;
  asMonSwitch[SQLM_TABLE_SW].input_state       = SQLM_HOLD;
  asMonSwitch[SQLM_BUFFER_POOL_SW].input_state = SQLM_HOLD;
  asMonSwitch[SQLM_LOCK_SW].input_state        = SQLM_HOLD;
  asMonSwitch[SQLM_SORT_SW].input_state        = SQLM_HOLD;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  iCallRc = DbtuTools_ApiWrapper_MonitorSwitches(asMonSwitch);
  /* ##### On error,... */
  if( iCallRc != 0 )
  {
   fprintf(STDERR, "%s",                                                                       NEWLINE);
   fprintf(STDERR, "===> ERROR: Checking the actual status of the monitor switches failed.%s", NEWLINE);
   fprintf(STDERR, "     RC = %i%s", iCallRc,                                                  NEWLINE);
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                                     NEWLINE);  
   fprintf(STDERR, "%s",                                                                       NEWLINE);
   iProgRc = 1;
   break;
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  if( asMonSwitch[SQLM_STATEMENT_SW].output_state != SQLM_ON )
  {
   fprintf(STDERR, "%s",                                                                     NEWLINE);
   fprintf(STDERR, "===> WARNING: The default monitor switch DFT_MON_STMT is not active.%s", NEWLINE);
   fprintf(STDERR, "              So you can not trust in the value '0 sec' found in the%s", NEWLINE);
   fprintf(STDERR, "              outputs 'Idle time' column.%s",                            NEWLINE);
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                                   NEWLINE);  
   fprintf(STDERR, "%s",                                                                     NEWLINE);
  }
  /* ----------------------------------------------------------------------- */



  /* ##### Activate the statement monitor switch */
  /* ----------------------------------------------------------------------- */
  asMonSwitch[SQLM_STATEMENT_SW].input_state = SQLM_ON;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  iCallRc = DbtuTools_ApiWrapper_MonitorSwitches(asMonSwitch);
  /* ##### On error,... */
  if( iCallRc != 0 )
  {
   fprintf(STDERR, "%s",                                                       NEWLINE);
   fprintf(STDERR, "===> ERROR: Changing the monitor switch status failed.%s", NEWLINE);
   fprintf(STDERR, "     RC = %i%s", iCallRc,                                  NEWLINE);
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                     NEWLINE);  
   fprintf(STDERR, "%s",                                                       NEWLINE);
   iProgRc = 1;
   break;
  }
  /* ----------------------------------------------------------------------- */



  /* ##### Allocate and fill the SQLMA structure                             */
  /* ##### TODO: Integrate DCS Applications (DRDA to mainframe,...) as well. */
  /* ----------------------------------------------------------------------- */
  psSqlMaStruct = (struct sqlma *) malloc(SQLMASIZE(1));
  /* ##### On error,... */
  if( psSqlMaStruct == NULL )
  {
   fprintf(STDERR, "%s",                                               NEWLINE);
   fprintf(STDERR, "===> ERROR: Memory allocation (malloc) failed.%s", NEWLINE);
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,             NEWLINE);  
   fprintf(STDERR, "%s",                                               NEWLINE);
   iProgRc = 1;
   break;
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  psSqlMaStruct->obj_num             = 1;
  psSqlMaStruct->obj_var[0].obj_type = SQLMA_APPL_ALL;
  /* ----------------------------------------------------------------------- */



  /* ##### Do snapshot for all applications */
  /* ----------------------------------------------------------------------- */
  iCallRc = DbtuTools_ApiWrapper_GetSnapshot(psSqlMaStruct,
                                             &pvStreamBuffer);
  /* ##### On error,... */
  if( iCallRc != 0 )
  {
   fprintf(STDERR, "%s",                                    NEWLINE);
   fprintf(STDERR, "===> ERROR: Taking snapshot failed.%s", NEWLINE);
   fprintf(STDERR, "     RC = %i%s", iCallRc,               NEWLINE);
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,  NEWLINE);  
   fprintf(STDERR, "%s",                                    NEWLINE);
   iProgRc = 1;
   break;
  }
  /* ----------------------------------------------------------------------- */



  /* ##### Parse the "self-describing data stream" for Appl informations */
  /* ##### SQLM_ELM_COLLECTED                                            */
  /* #####  - SQLM_ELM_APPL                                              */
  /* #####     - SQLM_ELM_APPL_IDLE_TIME                                 */
  /* #####     - SQLM_ELM_APPL_INFO                                      */
  /* #####        - SQLM_ELM_DB_NAME                                     */
  /* #####        - ...                                                  */
  /* ----------------------------------------------------------------------- */
  iFoundAppl = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_APPL,
                                                          pvStreamBuffer,
						          &pvFoundAppl,
						          1);
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  /* ##### On error,... */
  if( iFoundAppl < 0 )
  {
   fprintf(STDERR, "%s",                                                                     NEWLINE);
   fprintf(STDERR, "===> ERROR: Processing of the snapshot monitor output buffer failed.%s", NEWLINE);
   fprintf(STDERR, "            RC = %i%s", iFoundAppl,                                      NEWLINE);  
   fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                                   NEWLINE);  
   fprintf(STDERR, "%s",                                                                     NEWLINE);
   iProgRc = 1;
   break;
  }
  /* ----------------------------------------------------------------------- */



  /* ##### Print legend and header */
  /* ##### REMARK: It is important, that the output of the tool is the  */
  /* #####         same as for older version (other output formats need */
  /* #####         to be specified using additional parameters).        */
  /* ----------------------------------------------------------------------- */
  fprintf(STDOUT, "(A) = Connection type%s", NEWLINE);
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  if( iParamCoordNodeNumFlag == 1 )
  { fprintf(STDOUT, "(B) = Coordinating node number%s", NEWLINE); }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */    
  fprintf(STDOUT, "%s", NEWLINE);
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  fprintf(STDOUT, "    ");
  if( iParamCoordNodeNumFlag == 1 )  { fprintf(STDOUT, "    "); }
  fprintf(STDOUT, "DB       ");
  if( iParamClientDbAliasFlag == 1 ) { fprintf(STDOUT, "Client   "); }    
  fprintf(STDOUT, "Auth     Appl.        Appl.  Application          Idle    ");
  if( iParamClientNnameFlag )   { fprintf(STDOUT, "Client   "); }
  fprintf(STDOUT, "Client   Client Application Id /                Server %s", NEWLINE);
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  fprintf(STDOUT, "(A) ");
  if( iParamCoordNodeNumFlag == 1 )  { fprintf(STDOUT, "(B) "); }
  fprintf(STDOUT, "Name     ");
  if( iParamClientDbAliasFlag == 1 ) { fprintf(STDOUT, "DB Alias "); }  
  fprintf(STDOUT, "Id       Name         Handle Status               Time    ");  
  if( iParamClientNnameFlag == 1 )   { fprintf(STDOUT, "NNAME    "); }
  fprintf(STDOUT, "Login    PID    Network Informations            PID(s) %s", NEWLINE);
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  fprintf(STDOUT, "--- ");
  if( iParamCoordNodeNumFlag == 1 )  { fprintf(STDOUT, "--- "); }
  fprintf(STDOUT, "-------- ");
  if( iParamClientDbAliasFlag == 1 ) { fprintf(STDOUT, "-------- "); }
  fprintf(STDOUT, "-------- ------------ ------ -------------------- ------- ");
  if( iParamClientNnameFlag == 1 )   { fprintf(STDOUT, "-------- "); }
  fprintf(STDOUT, "-------- ------ ------------------------------- ------>%s", NEWLINE);
  /* ----------------------------------------------------------------------- */



  /* ##### Walk through the found application(s) */
  /* ----------------------------------------------------------------------- */ 
  ppsElementAppl = pvFoundAppl;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */  
  for( iLoopAppl = 0; iLoopAppl < iFoundAppl; iLoopAppl++ )
  {
   /* ##### Build pseudo-loop (helps to free memory at only one location in the sourcecode) */
   for(;;)
   {
    /* ##### Parse the informations for this application (I) */
    iCallRc = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_APPL_INFO, *ppsElementAppl, &pvFoundApplInfo, 1);
    /* ##### On error,... */
    if(iCallRc != 1)
    {
     fprintf(STDERR, "%s",                                                                     NEWLINE);
     fprintf(STDERR, "===> ERROR: Processing of the snapshot monitor output buffer failed.%s", NEWLINE);
     fprintf(STDERR, "            RC = %i%s", iCallRc,                                         NEWLINE);
     fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                                   NEWLINE);  
     fprintf(STDERR, "%s",                                                                     NEWLINE);
     iProgRc = 1;
     break;    
    }

    /* ##### Parse the informations for this application (II) */
    ppsElementApplInfo = pvFoundApplInfo;
    aiCallRc[0]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_COORD_NODE_NUM,  *ppsElementApplInfo, &pvFoundCoordNodeNum,   1);
    aiCallRc[1]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_DB_NAME,         *ppsElementApplInfo, &pvFoundDbName,         1);
    aiCallRc[2]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_CLIENT_DB_ALIAS, *ppsElementApplInfo, &pvFoundClientDbAlias,  1);
    aiCallRc[3]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_AUTH_ID,         *ppsElementApplInfo, &pvFoundAuthId,         1);
    aiCallRc[4]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_APPL_NAME,       *ppsElementApplInfo, &pvFoundApplName,       1);
    aiCallRc[5]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_AGENT_ID,        *ppsElementApplInfo, &pvFoundAgentId,        1);
    aiCallRc[6]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_APPL_STATUS,     *ppsElementApplInfo, &pvFoundApplStatus,     1);
    aiCallRc[7]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_APPL_IDLE_TIME,  *ppsElementAppl,     &pvFoundApplIdleTime,   1);
    aiCallRc[8]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_CLIENT_NNAME,    *ppsElementApplInfo, &pvFoundClientNname,    1);
    aiCallRc[9]  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_EXECUTION_ID,    *ppsElementApplInfo, &pvFoundExecutionId,    1);
    aiCallRc[10] = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_CLIENT_PID,      *ppsElementApplInfo, &pvFoundClientPid,      1);
    aiCallRc[11] = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_CLIENT_PROTOCOL, *ppsElementApplInfo, &pvFoundClientProtocol, 1);
    aiCallRc[12] = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_APPL_ID,         *ppsElementApplInfo, &pvFoundApplId,         1);
    iFoundAgent  = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_AGENT,           *ppsElementAppl,     &pvFoundAgent,          99);
    /* ##### On error,... */
    if( (aiCallRc[0] != 1) ||
        (aiCallRc[1] != 1) ||
	(aiCallRc[2] != 1) ||
	(aiCallRc[3] != 1) ||
	(aiCallRc[4] != 1) ||
	(aiCallRc[5] != 1) ||
	(aiCallRc[6] != 1) ||
	(aiCallRc[7] != 1) ||
	(aiCallRc[8] != 1) ||
	(aiCallRc[9] != 1) ||	
	(aiCallRc[10] != 1) ||	
	(aiCallRc[11] != 1) ||			
	(aiCallRc[12] != 1) ||		
	(iFoundAgent < 0) )
    {
     fprintf(STDERR, "%s",                                                                     NEWLINE);
     fprintf(STDERR, "===> ERROR: Processing of the snapshot monitor output buffer failed.%s", NEWLINE);
     fprintf(STDERR, "            RC = %i / %i / %i / %i / %i%s", aiCallRc[0],  aiCallRc[1],  aiCallRc[2], aiCallRc[3], aiCallRc[4], NEWLINE);
     fprintf(STDERR, "                 %i / %i / %i / %i / %i%s", aiCallRc[5],  aiCallRc[6],  aiCallRc[7], aiCallRc[8], aiCallRc[9], NEWLINE);
     fprintf(STDERR, "                 %i / %i / %i%s",           aiCallRc[10], aiCallRc[11], iFoundAgent, NEWLINE);     
     fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                                   NEWLINE);  
     fprintf(STDERR, "%s",                                                                     NEWLINE);
     iProgRc = 1;
     break;
    }
    
    /* ##### Print the collected data */
    fprintf(STDOUT, "DB  ");
    if( iParamCoordNodeNumFlag == 1 )
    { ppsDummy = pvFoundCoordNodeNum;  iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%3.3s ",    acDummy); }
    ppsDummy = pvFoundDbName;          iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%-8.8s ",   acDummy);
    if( iParamClientDbAliasFlag == 1 )
    { ppsDummy = pvFoundClientDbAlias; iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%-8.8s ",   acDummy); }
    ppsDummy = pvFoundAuthId;          iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%-8.8s ",   acDummy);
    ppsDummy = pvFoundApplName;        iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%-12.12s ", acDummy);
    ppsDummy = pvFoundAgentId;         iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%6.6s ",    acDummy);
    ppsDummy = pvFoundApplStatus;      iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_APPLSTATUS, acDummy, 64);    fprintf(STDOUT, "%-20.20s ", acDummy);
    ppsDummy = pvFoundApplIdleTime;    iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_APPLIDLETIME, acDummy, 64);  fprintf(STDOUT, "%7.7s ",   acDummy);
    if( iParamClientNnameFlag == 1 )
    { ppsDummy = pvFoundClientNname;   iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_STRINGORHYPEN, acDummy, 64); fprintf(STDOUT, "%-8.8s ",   acDummy); }
    ppsDummy = pvFoundExecutionId;     iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_STRINGORHYPEN, acDummy, 64); fprintf(STDOUT, "%-8.8s ",   acDummy);
    ppsDummy = pvFoundClientPid;       iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%6.6s ",    acDummy);
    if( iParamHumanReadableFlag == 1)
    {
     ppsDummy = pvFoundClientProtocol; iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       iDummy = atoi(acDummy);
     if( iDummy == SQLM_PROT_TCPIP )
     { ppsDummy = pvFoundApplId;       iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_APPLID_TCPIP, acDummy, 64);  fprintf(STDOUT, "%-31.31s ", acDummy); }
     else
     { ppsDummy = pvFoundApplId;       iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%-31.31s ", acDummy); }
    }
    else
    { ppsDummy = pvFoundApplId;        iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);       fprintf(STDOUT, "%-31.31s ", acDummy); }

    /* ##### Parse and print the information for the agents related to the application */    
    iDummy = 0;
    ppsElementAgent = pvFoundAgent;
    for( iLoopAgent = 0; iLoopAgent < iFoundAgent; iLoopAgent++ )
    {
     /* ##### Parse the agent informations for agent PID */
     iFoundAgentPid = DbtuTools_Parser_FindSnapshotBufferElement(SQLM_ELM_AGENT_PID, *ppsElementAgent, &pvFoundAgentPid, 1);
     /* ##### On error,... */
     if( iFoundAgentPid <= 0 )
     { 
      fprintf(STDERR, "%s",                                                                     NEWLINE);
      fprintf(STDERR, "===> ERROR: Processing of the snapshot monitor output buffer failed.%s", NEWLINE);
      fprintf(STDERR, "            RC = %i%s", iFoundAgentPid,                                  NEWLINE);  
      fprintf(STDERR, "     [%s (%i)]%s", __FILE__, __LINE__,                                   NEWLINE);  
      fprintf(STDERR, "%s",                                                                     NEWLINE);
      iProgRc = 1;
      break;
     }
     /* ##### Go through the found agent PID's and print that information */
     ppsDummy = pvFoundAgentPid;
     for( iLoopAgentPid = 0; iLoopAgentPid < iFoundAgentPid; iLoopAgentPid++ )
     {
      iDummy++;
      iCallRc = DbtuTools_Converter_SnapshotBufferElement2String(*ppsDummy, DBTUTOOLS_FORMAT_OUTPUT_DEFAULT, acDummy, 64);
      if( iDummy == 1 ) { fprintf(STDOUT, "%s",  acDummy ); }
      else              { fprintf(STDOUT, ",%s", acDummy ); }
      ppsDummy++;
     }
     /* ##### Free memory */
     free(pvFoundAgentPid);
     pvFoundAgentPid = NULL;
     /* ##### Jump to next agent PID */
     ppsElementAgent++;
    }

    /* ##### Print the end of line */  
    fprintf(STDOUT, "%s", NEWLINE);

    /* ##### Leave pseudo-loop */
    break;
   }

   /* ##### Free memory */
   if( pvFoundApplInfo != NULL )       { free(pvFoundApplInfo);       pvFoundApplInfo       = NULL; } 
   if( pvFoundDbName != NULL )         { free(pvFoundDbName);         pvFoundDbName         = NULL; } 
   if( pvFoundClientDbAlias != NULL )  { free(pvFoundClientDbAlias);  pvFoundClientDbAlias  = NULL; } 
   if( pvFoundAuthId != NULL )         { free(pvFoundAuthId);         pvFoundAuthId         = NULL; }
   if( pvFoundApplName != NULL )       { free(pvFoundApplName);       pvFoundApplName       = NULL; } 
   if( pvFoundAgentId != NULL )        { free(pvFoundAgentId);        pvFoundAgentId        = NULL; } 
   if( pvFoundApplStatus != NULL )     { free(pvFoundApplStatus);     pvFoundApplStatus     = NULL; } 
   if( pvFoundApplIdleTime != NULL )   { free(pvFoundApplIdleTime);   pvFoundApplIdleTime   = NULL; } 
   if( pvFoundClientNname != NULL )    { free(pvFoundClientNname);    pvFoundClientNname    = NULL; }        
   if( pvFoundExecutionId != NULL )    { free(pvFoundExecutionId);    pvFoundExecutionId    = NULL; } 
   if( pvFoundClientPid != NULL )      { free(pvFoundClientPid);      pvFoundClientPid      = NULL; }    
   if( pvFoundClientProtocol != NULL ) { free(pvFoundClientProtocol); pvFoundClientProtocol = NULL; } 
   if( pvFoundApplId != NULL )         { free(pvFoundApplId);         pvFoundApplId         = NULL; } 
   if( pvFoundAgent != NULL )          { free(pvFoundAgent);          pvFoundAgent          = NULL; } 
   if( pvFoundAgentPid != NULL )       { free(pvFoundAgentPid);       pvFoundAgentPid       = NULL; } 

   /* ##### On error,... */
   if( iProgRc != 0 )
   { break; }
   /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
   ppsElementAppl++;
   /* ---------------------------------------------------------------------- */   
  }
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  fprintf(STDOUT, "%s", NEWLINE);
  /* ----------------------------------------------------------------------- */



  /* ##### Leave "Prevent nested IF's"-Loop */
  break;
 }
 /* ----------------------------------------------------------------------- */



 /* ##### Free allocated memory */
 /* ------------------------------------------------------------------------ */
 if( pvFoundAppl != NULL )
 { free(pvFoundAppl); }
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- */
 if( psSqlMaStruct != NULL )
 { free(psSqlMaStruct); }
 /* ------------------------------------------------------------------------ */



 /* ##### End the program */
 /* ------------------------------------------------------------------------ */ 
 return(iProgRc);
 /* ------------------------------------------------------------------------ */ 
}




