/* ######################################################################### */
/* ##                                                                     ## */
/* ##  D B T U T O O L S / D B T U P R E P T I M E . J A V A              ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Job .......: Program that converts an given consistency token      ## */
/* ##               into an timestamp.                                    ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Copyright (C) 2002  Daniel Scheibli                                ## */
/* ##                                                                     ## */
/* ##  This program is free software; you can redistribute it and/or      ## */
/* ##  modify it under the terms of the GNU General Public License        ## */
/* ##  as published by the Free Software Foundation; either version 2     ## */
/* ##  of the License, or (at your option) any later version.             ## */
/* ##                                                                     ## */
/* ##  This program is distributed in the hope that it will be useful,    ## */
/* ##  but WITHOUT ANY WARRANTY; without even the implied warranty of     ## */
/* ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      ## */
/* ##  GNU General Public License for more details.                       ## */
/* ##                                                                     ## */
/* ##  You should have received a copy of the GNU General Public License  ## */
/* ##  along with this program; if not, write to the Free Software        ## */
/* ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,             ## */
/* ##  MA  02111-1307, USA.                                               ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Remark ....: <none>                                                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>        ## */
/* ##  Date ......: 2002-04-23                                            ## */
/* ##  Changes ...: ----- dbtupreptime.java V00.99/R020 ----------------- ## */
/* ##               <none>                                                ## */
/* ##               ----- dbtupreptime.java V00.99/R011 ----------------- ## */
/* ##               2002-09-16 - Renamed the package hosting this class   ## */
/* ##                            (was org.edelbyte.DbtuTools).            ## */
/* ##               ----- dbtupreptime.java V00.99/R010 ----------------- ## */
/* ##               2002-08-10 - Port from C to Java.                     ## */
/* ##               ----- dbtupreptime.c V00.99/R002 -------------------- ## */
/* ##               2002-05-12 - Move of conversion function to the       ## */
/* ##                            central codefile.                        ## */
/* ##               2002-05-12 - Shift to central headerfile.             ## */
/* ##               2002-05-07 - Change from printf() to fprintf().       ## */
/* ##               ----- dbtupreptime.c V00.99/R001 -------------------- ## */
/* ##               <none>                                                ## */
/* ##                                                                     ## */
/* ######################################################################### */



/* ##### Presettings */
/* ------------------------------------------------------------------------- */
package org.dbtutools.DbtuTools;
/* ------------------------------------------------------------------------- */





/* ##### Class definition */
/* ------------------------------------------------------------------------- */
public class dbtupreptime
{
 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   < M A I N >                                                      ## */
 /* ##                                                                    ## */ 
 /* ######################################################################## */
 public static void main( java.lang.String aoArgs[] )
 {
  /* ##### Presettings */
  /* ----------------------------------------------------------------------- */
  java.lang.String oTimestamp = new java.lang.String();
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  int              iProgRc    = 0;
  /* ----------------------------------------------------------------------- */  



  /* ##### "Prevent nested IF's"-Loop */
  /* ----------------------------------------------------------------------- */  
  LOOP1: for(;;)
  {
   /* ##### Check the given arguments */
   /* ---------------------------------------------------------------------- */
   if( aoArgs.length != 1 )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: A minimum of one argument was expected." );
    (new java.lang.Exception("Error location")).printStackTrace();
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Usage .......: >>--- dbtupreptime ---- CT ---><" );
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Sample ......: dbtupreptime aAiXVXES" );
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Arguments ...: CT   The Consistency Token which should" );
    java.lang.System.err.println( "                    be converted into a timestamp." );    
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Do conversion */
   /* ---------------------------------------------------------------------- */
   try
   { oTimestamp = org.dbtutools.DbtuTools.core.db2.BindFile.toTimestamp(aoArgs[0]); }
   catch( java.lang.NumberFormatException oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: Conversion failed." );
    oException.printStackTrace();    
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;    
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Print result */
   /* ---------------------------------------------------------------------- */
   java.lang.System.out.println( "" );
   java.lang.System.out.println( "The consistency token stands for '" + oTimestamp.toString() + "'" );
   java.lang.System.out.println( "" );
   /* ---------------------------------------------------------------------- */


  
   /* ##### Leave "Prevent nested IF's"-Loop */
   break LOOP1;
  }
  /* ----------------------------------------------------------------------- */    
  
  
  
  /* ##### End of program */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.exit( iProgRc );
  /* ----------------------------------------------------------------------- */  
 }
}
/* ------------------------------------------------------------------------- */




