/* ######################################################################### */
/* ##                                                                     ## */
/* ##  U T I L / U N K N O W N V A L U E E X C E P T I O N . J A V A      ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Job .......: Class providing an Exception for any case, where      ## */
/* ##               no useful return code can be returned.                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Copyright (C) 2002  Daniel Scheibli                                ## */
/* ##                                                                     ## */
/* ##  This program is free software; you can redistribute it and/or      ## */
/* ##  modify it under the terms of the GNU General Public License        ## */
/* ##  as published by the Free Software Foundation; either version 2     ## */
/* ##  of the License, or (at your option) any later version.             ## */
/* ##                                                                     ## */
/* ##  This program is distributed in the hope that it will be useful,    ## */
/* ##  but WITHOUT ANY WARRANTY; without even the implied warranty of     ## */
/* ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      ## */
/* ##  GNU General Public License for more details.                       ## */
/* ##                                                                     ## */
/* ##  You should have received a copy of the GNU General Public License  ## */
/* ##  along with this program; if not, write to the Free Software        ## */
/* ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,             ## */
/* ##  MA  02111-1307, USA.                                               ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Remark ....: <none>                                                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>        ## */
/* ##  Date ......: 2002-10-10                                            ## */
/* ##  Changes ...: ----- UnknownValueException.java V00.99/R020 -------- ## */
/* ##               <none>                                                ## */
/* ##               ----- UnknownValueException.java V00.99/R011 -------- ## */
/* ##               <none>                                                ## */
/* ##                                                                     ## */
/* ######################################################################### */



/* ##### Presettings */
/* ------------------------------------------------------------------------- */
package org.edelbyte.util;
/* ------------------------------------------------------------------------- */





/* ##### Class definition */
/** ************************************************************************
 * Checked exception thrown in cases where no useful return code
 * can be provided / returned.
 * @author Daniel Scheibli &lt;daniel.scheibli at edelbyte.org&gt;
 * ************************************************************************* */
public class UnknownValueException extends Exception
{
 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   U N K N O W N V A L U E E X C E P T I O N ()                     ## */ 
 /* ##                                                                    ## */
 /* ######################################################################## */ 
 /** ***********************************************************************
  * Constructs an UnknownValueException with no detailed message.
  * ************************************************************************ */
 public UnknownValueException( )
 { super(); }





 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   U N K N O W N V A L U E E X C E P T I O N ()                     ## */ 
 /* ##                                                                    ## */
 /* ######################################################################## */ 
 /** ***********************************************************************
  * Constructs an UnknownValueException with the specified
  * detailed message.
  *
  * @param oMessage
  *        The String that contains the detailed message.
  * ************************************************************************ */
 public UnknownValueException( java.lang.String oMessage )
 { super( oMessage ); }
}
/* ------------------------------------------------------------------------- */


